
package de.ivu.elect.business.wahl.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahl.entity.Wahlart;

@RequestScoped
@Named(WahlartConversationSelect.COMPONENT_NAME)
public class WahlartConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlartConversationSelect";

  @Inject
  protected transient WahlartExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WahlartConversationStore.class)
  protected transient WahlartConversationStore conversationStore;

  public WahlartConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Wahlart getEntity() {
    return getEntityInternal();
  }

  private Wahlart getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Wahlart entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.wahl.entity.WahlartPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Wahlart entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.wahl.entity.WahlartPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.wahl.entity.WahlartPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Wahlart attach(Wahlart entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Wahlart attach( de.ivu.elect.business.wahl.entity.WahlartPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
